> For the complete documentation index, see [llms.txt](https://docs.parallels.com/landing/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/infrastructure/connection-brokers.md).

# Connection Brokers

## List

> Retrieve information about a list of RAS Connection Broker servers.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/ConnectionBroker":{"get":{"tags":["0-Infrastructure/Connection Brokers//0-Basic Operations"],"summary":"List","description":"Retrieve information about a list of RAS Connection Broker servers.","operationId":"6768eabc-17c1-46e0-823c-53771bbfe9da","parameters":[{"name":"SiteId","in":"query","description":"Site ID for which to retrieve the RAS Connection Broker server information (optional)","schema":{"type":"integer","format":"int32"}},{"name":"Server","in":"query","description":"Filter the result by server name (optional)","schema":{"type":"string"}}],"responses":{"200":{"description":"Success","content":{"application/json; api-version=1.0":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ConnectionBroker"}}}}},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ConnectionBroker":{"type":"object","properties":{"id":{"type":"integer","description":"<para type=\"description\">ID of the object.</para>","format":"int32"},"adminCreate":{"type":"string","description":"<para type=\"description\">User who created the object.</para>","nullable":true},"adminLastMod":{"type":"string","description":"<para type=\"description\">User who last modified the object.</para>","nullable":true},"timeCreate":{"type":"string","description":"<para type=\"description\">Time when the object was created.</para>","format":"date-time"},"timeLastMod":{"type":"string","description":"<para type=\"description\">Time when the object was last modified.</para>","format":"date-time"},"server":{"type":"string","description":"<para type=\"description\">Server name.</para>","nullable":true},"enabled":{"type":"boolean","description":"<para type=\"description\">Whether the server is enabled or not.</para>"},"description":{"type":"string","description":"<para type=\"description\">Description of the server.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">ID of the site.</para>","format":"int32"},"priority":{"type":"integer","description":"<para type=\"description\">Priority of the specified RAS Connection Broker.</para>","format":"int32"},"ip":{"type":"string","description":"<para type=\"description\">IP address of RAS Connection Broker.</para>","nullable":true},"alternativeIPs":{"type":"string","description":"<para type=\"description\">Alternative IPs to access the RAS Connection Broker.</para>","nullable":true},"standby":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is in standby mode or not.</para>"},"markedForDeletion":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is marked for deletion or not.</para>"},"inheritAPISettings":{"type":"boolean","description":"<para type=\"description\">Whether API settings are enabled or disabled.</para>"},"apiSettings":{"$ref":"#/components/schemas/APISettings"}},"additionalProperties":false,"description":"<para type=\"synopsis\">Connection Broker</para>\r\n<para type=\"description\"></para>"},"APISettings":{"type":"object","properties":{"minSSLVersion":{"$ref":"#/components/schemas/AcceptedSSLVersion"},"cipherStrength":{"$ref":"#/components/schemas/CipherStrength"},"cipher":{"type":"string","description":"<para type=\"description\">Cipher string.</para>","nullable":true},"cipherPreference":{"type":"boolean","description":"<para type=\"description\">Enable or disable Use ciphers according to server preference.</para>"},"certificateId":{"type":"integer","description":"<para type=\"description\">The ID of the specific Certificate to be used.</para>","format":"int32"},"enableAPI":{"type":"boolean","description":"<para type=\"description\">Whether the API is enabled or disabled.</para>"},"apiPort":{"type":"integer","description":"<para type=\"description\">The API port.</para>","format":"int32"},"apiToken":{"type":"string","description":"<para type=\"description\">The API token.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">RAS Connection Broker API Settings</para>\r\n<para type=\"description\"></para>"},"AcceptedSSLVersion":{"enum":[["2 = TLSv1","3 = TLSv1_1","4 = TLSv1_2","5 = TLSv1_3"]],"type":"string","description":"<para type=\"synopsis\">Accepted SSL Versions</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"CipherStrength":{"enum":[["0 = Low","1 = Medium","2 = High","3 = Custom"]],"type":"string","description":"<para type=\"synopsis\">Cipher Strength</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```

## Create

> Add a new RAS Connection Broker server to a site. The agent software will be installed on the server by default. You can optionally skip the agent installation by including the \`\`\`noInstall\`\`\` parameter.

````json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/ConnectionBroker":{"post":{"tags":["0-Infrastructure/Connection Brokers//0-Basic Operations"],"summary":"Create","description":"Add a new RAS Connection Broker server to a site. The agent software will be installed on the server by default. You can optionally skip the agent installation by including the ```noInstall``` parameter.","operationId":"7ea14def-c18c-437e-a36c-59592644e54d","parameters":[{"name":"noInstall","in":"query","description":"Specifies not to install the agent software on the server.\r\n           If you omit this parameter, the agent will be push installed on the server using your RAS admin credentials\r\n           To specify different credentials, include the Username and Password parameters.","schema":{"type":"boolean"}},{"name":"username","in":"query","description":"An administrator account for push installing the agent on the server.\r\n            If this parameter is omitted, your RAS admin username and password will be used.","schema":{"type":"string"}},{"name":"password","in":"query","description":"The password of the account specified in the Username parameter.","schema":{"type":"string"}},{"name":"noRestart","in":"query","description":"Specifies not to restart the server after the RAS Connection Broker is installed.\r\n            If this parameter is omitted, the server will be restarted if required.","schema":{"type":"boolean"}},{"name":"noFireWallRules","in":"query","description":"Specifies not to add firewall rules to allow the RD Session Host and the Connection Broker to communicate.\r\n            If this parameter is omitted, the firewall rules will not be added.","schema":{"type":"boolean"}}],"requestBody":{"description":"RAS Connection Broker server","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/NewConnectionBroker"}}}},"responses":{"201":{"description":"Created","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ConnectionBroker"}}}},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"NewConnectionBroker":{"required":["server"],"type":"object","properties":{"server":{"type":"string","description":"<para type=\"description\">FQDN or IP address of the server to add to a site as a RAS Connection Broker.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">Site ID to which to add the RAS Connection Broker server.</para>\r\n<para type=\"description\">If the parameter is omitted, the Licensing Server site ID will be used.</para>","format":"int32"}},"additionalProperties":false,"description":"<para type=\"synopsis\">Create a new Connection Broker</para>\r\n<para type=\"description\"></para>"},"ConnectionBroker":{"type":"object","properties":{"id":{"type":"integer","description":"<para type=\"description\">ID of the object.</para>","format":"int32"},"adminCreate":{"type":"string","description":"<para type=\"description\">User who created the object.</para>","nullable":true},"adminLastMod":{"type":"string","description":"<para type=\"description\">User who last modified the object.</para>","nullable":true},"timeCreate":{"type":"string","description":"<para type=\"description\">Time when the object was created.</para>","format":"date-time"},"timeLastMod":{"type":"string","description":"<para type=\"description\">Time when the object was last modified.</para>","format":"date-time"},"server":{"type":"string","description":"<para type=\"description\">Server name.</para>","nullable":true},"enabled":{"type":"boolean","description":"<para type=\"description\">Whether the server is enabled or not.</para>"},"description":{"type":"string","description":"<para type=\"description\">Description of the server.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">ID of the site.</para>","format":"int32"},"priority":{"type":"integer","description":"<para type=\"description\">Priority of the specified RAS Connection Broker.</para>","format":"int32"},"ip":{"type":"string","description":"<para type=\"description\">IP address of RAS Connection Broker.</para>","nullable":true},"alternativeIPs":{"type":"string","description":"<para type=\"description\">Alternative IPs to access the RAS Connection Broker.</para>","nullable":true},"standby":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is in standby mode or not.</para>"},"markedForDeletion":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is marked for deletion or not.</para>"},"inheritAPISettings":{"type":"boolean","description":"<para type=\"description\">Whether API settings are enabled or disabled.</para>"},"apiSettings":{"$ref":"#/components/schemas/APISettings"}},"additionalProperties":false,"description":"<para type=\"synopsis\">Connection Broker</para>\r\n<para type=\"description\"></para>"},"APISettings":{"type":"object","properties":{"minSSLVersion":{"$ref":"#/components/schemas/AcceptedSSLVersion"},"cipherStrength":{"$ref":"#/components/schemas/CipherStrength"},"cipher":{"type":"string","description":"<para type=\"description\">Cipher string.</para>","nullable":true},"cipherPreference":{"type":"boolean","description":"<para type=\"description\">Enable or disable Use ciphers according to server preference.</para>"},"certificateId":{"type":"integer","description":"<para type=\"description\">The ID of the specific Certificate to be used.</para>","format":"int32"},"enableAPI":{"type":"boolean","description":"<para type=\"description\">Whether the API is enabled or disabled.</para>"},"apiPort":{"type":"integer","description":"<para type=\"description\">The API port.</para>","format":"int32"},"apiToken":{"type":"string","description":"<para type=\"description\">The API token.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">RAS Connection Broker API Settings</para>\r\n<para type=\"description\"></para>"},"AcceptedSSLVersion":{"enum":[["2 = TLSv1","3 = TLSv1_1","4 = TLSv1_2","5 = TLSv1_3"]],"type":"string","description":"<para type=\"synopsis\">Accepted SSL Versions</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"CipherStrength":{"enum":[["0 = Low","1 = Medium","2 = High","3 = Custom"]],"type":"string","description":"<para type=\"synopsis\">Cipher Strength</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
````

## Get

> Retrieve a specific Connection Broker by ID.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/ConnectionBroker/{id}":{"get":{"tags":["0-Infrastructure/Connection Brokers//0-Basic Operations"],"summary":"Get","description":"Retrieve a specific Connection Broker by ID.","operationId":"899a40ca-6e76-4fec-9ab1-2c60f1002ea5","parameters":[{"name":"id","in":"path","description":"RAS Connection Broker server ID","required":true,"schema":{"type":"integer","format":"int32"}}],"responses":{"200":{"description":"Success","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ConnectionBroker"}}}},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ConnectionBroker":{"type":"object","properties":{"id":{"type":"integer","description":"<para type=\"description\">ID of the object.</para>","format":"int32"},"adminCreate":{"type":"string","description":"<para type=\"description\">User who created the object.</para>","nullable":true},"adminLastMod":{"type":"string","description":"<para type=\"description\">User who last modified the object.</para>","nullable":true},"timeCreate":{"type":"string","description":"<para type=\"description\">Time when the object was created.</para>","format":"date-time"},"timeLastMod":{"type":"string","description":"<para type=\"description\">Time when the object was last modified.</para>","format":"date-time"},"server":{"type":"string","description":"<para type=\"description\">Server name.</para>","nullable":true},"enabled":{"type":"boolean","description":"<para type=\"description\">Whether the server is enabled or not.</para>"},"description":{"type":"string","description":"<para type=\"description\">Description of the server.</para>","nullable":true},"siteId":{"type":"integer","description":"<para type=\"description\">ID of the site.</para>","format":"int32"},"priority":{"type":"integer","description":"<para type=\"description\">Priority of the specified RAS Connection Broker.</para>","format":"int32"},"ip":{"type":"string","description":"<para type=\"description\">IP address of RAS Connection Broker.</para>","nullable":true},"alternativeIPs":{"type":"string","description":"<para type=\"description\">Alternative IPs to access the RAS Connection Broker.</para>","nullable":true},"standby":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is in standby mode or not.</para>"},"markedForDeletion":{"type":"boolean","description":"<para type=\"description\">Whether the RAS Connection Broker is marked for deletion or not.</para>"},"inheritAPISettings":{"type":"boolean","description":"<para type=\"description\">Whether API settings are enabled or disabled.</para>"},"apiSettings":{"$ref":"#/components/schemas/APISettings"}},"additionalProperties":false,"description":"<para type=\"synopsis\">Connection Broker</para>\r\n<para type=\"description\"></para>"},"APISettings":{"type":"object","properties":{"minSSLVersion":{"$ref":"#/components/schemas/AcceptedSSLVersion"},"cipherStrength":{"$ref":"#/components/schemas/CipherStrength"},"cipher":{"type":"string","description":"<para type=\"description\">Cipher string.</para>","nullable":true},"cipherPreference":{"type":"boolean","description":"<para type=\"description\">Enable or disable Use ciphers according to server preference.</para>"},"certificateId":{"type":"integer","description":"<para type=\"description\">The ID of the specific Certificate to be used.</para>","format":"int32"},"enableAPI":{"type":"boolean","description":"<para type=\"description\">Whether the API is enabled or disabled.</para>"},"apiPort":{"type":"integer","description":"<para type=\"description\">The API port.</para>","format":"int32"},"apiToken":{"type":"string","description":"<para type=\"description\">The API token.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">RAS Connection Broker API Settings</para>\r\n<para type=\"description\"></para>"},"AcceptedSSLVersion":{"enum":[["2 = TLSv1","3 = TLSv1_1","4 = TLSv1_2","5 = TLSv1_3"]],"type":"string","description":"<para type=\"synopsis\">Accepted SSL Versions</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"CipherStrength":{"enum":[["0 = Low","1 = Medium","2 = High","3 = Custom"]],"type":"string","description":"<para type=\"synopsis\">Cipher Strength</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```

## Update

> Modify settings of a RAS Connection Broker server. For each setting, the request has a corresponding parameter. To modify a setting, specify a matching parameter and its value.

```json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/ConnectionBroker/{id}":{"put":{"tags":["0-Infrastructure/Connection Brokers//0-Basic Operations"],"summary":"Update","description":"Modify settings of a RAS Connection Broker server. For each setting, the request has a corresponding parameter. To modify a setting, specify a matching parameter and its value.","operationId":"116328f8-e283-4259-ac9d-48044d48cd65","parameters":[{"name":"id","in":"path","description":"RAS Connection Broker server ID","required":true,"schema":{"type":"integer","format":"int32"}}],"requestBody":{"description":"RAS Connection Broker server","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/SetConnectionBroker"}}}},"responses":{"204":{"description":"No Content"},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"SetConnectionBroker":{"type":"object","properties":{"enabled":{"type":"boolean","description":"<para type=\"description\">Enable or disable the specified RAS Connection Broker.</para>","nullable":true},"description":{"type":"string","description":"<para type=\"description\">A user-defined RAS Connection Broker description.</para>","nullable":true},"ip":{"maxLength":255,"minLength":0,"type":"string","description":"<para type=\"description\">An IP address of the RAS Connection Broker server.</para>","nullable":true},"alternativeIPs":{"maxLength":255,"minLength":0,"type":"string","description":"<para type=\"description\">A list of alternative IP addresses separated by a comma.</para>","nullable":true},"standby":{"type":"boolean","description":"<para type=\"description\">Set the specified RAS Secondary Connection Broker in Standby (or vice versa).</para>","nullable":true},"inheritAPISettings":{"type":"boolean","description":"<para type=\"description\">Enable or disable default API settings.</para>","nullable":true},"enableAPI":{"type":"boolean","description":"<para type=\"description\">Enable or disable the API.</para>","nullable":true},"apiPort":{"type":"integer","description":"<para type=\"description\">API port number.</para>","format":"int32","nullable":true},"minSSLVersion":{"$ref":"#/components/schemas/AcceptedSSLVersion"},"cipherStrength":{"$ref":"#/components/schemas/CipherStrength"},"cipher":{"maxLength":255,"minLength":0,"type":"string","description":"<para type=\"description\">Cipher string.</para>","nullable":true},"cipherPreference":{"type":"boolean","description":"<para type=\"description\">Enable or disable Use ciphers according to server preference.</para>","nullable":true},"certificateId":{"type":"integer","description":"<para type=\"description\">The Certificate ID.</para>","format":"int32","nullable":true},"apiToken":{"maxLength":40,"minLength":1,"type":"string","description":"<para type=\"description\">API token.</para>","nullable":true}},"additionalProperties":false,"description":"<para type=\"synopsis\">Update a Connection Broker settings</para>\r\n<para type=\"description\"></para>"},"AcceptedSSLVersion":{"enum":[["2 = TLSv1","3 = TLSv1_1","4 = TLSv1_2","5 = TLSv1_3"]],"type":"string","description":"<para type=\"synopsis\">Accepted SSL Versions</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"CipherStrength":{"enum":[["0 = Low","1 = Medium","2 = High","3 = Custom"]],"type":"string","description":"<para type=\"synopsis\">Cipher Strength</para>\r\n<para type=\"description\"></para>\r\n<para type=\"description\"></para>","format":"int32"},"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
```

## Delete

> Delete a RAS Connection Broker server from a site. The RAS Connection Broker server will be uninstalled from the server by default. You can optionally keep it by including the \`\`\`noUninstall\`\`\` parameter.

````json
{"openapi":"3.0.1","info":{"title":"Parallels RAS - REST API v1.0","version":"1.0"},"paths":{"/api/ConnectionBroker/{id}":{"delete":{"tags":["0-Infrastructure/Connection Brokers//0-Basic Operations"],"summary":"Delete","description":"Delete a RAS Connection Broker server from a site. The RAS Connection Broker server will be uninstalled from the server by default. You can optionally keep it by including the ```noUninstall``` parameter.","operationId":"d4479ff0-a3e0-45d9-9602-a10e732ca08f","parameters":[{"name":"noUninstall","in":"query","description":"Include this parameter if you wish to keep the RAS Connection Broker software on the server.\r\n            To uninstall the agent software, omit this parameter.\r\n            When uninstalling the agent, your RAS admin credentials will be used by default.\r\n            You can specify different credentials by including the Username and Password parameters.","schema":{"type":"boolean"}},{"name":"username","in":"query","description":"A username that will be used to remotely uninstall the RAS Connection Broker software from the target server.\r\n            If this parameter is omitted, your RAS admin username and password will be used by default.","schema":{"type":"string"}},{"name":"password","in":"query","description":"The password of the account specified in the Username parameter.","schema":{"type":"string"}},{"name":"id","in":"path","description":"RAS Connection Broker server ID","required":true,"schema":{"type":"integer","format":"int32"}}],"responses":{"204":{"description":"No Content"},"401":{"description":"Unauthorized","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/json; api-version=1.0":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":"string","nullable":true},"title":{"type":"string","nullable":true},"status":{"type":"integer","format":"int32","nullable":true},"detail":{"type":"string","nullable":true},"instance":{"type":"string","nullable":true}},"additionalProperties":{}}}}}
````


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.parallels.com/landing/ras-rest-api-guide/api-reference/infrastructure/connection-brokers.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
